/*
mega8
*/

prog_int8_t osccal=0xFF;

#define BIT(y)	(1<<(y))

#define USR_N		54//64
#define TIME_CH		99
#define TIME_DECH	1

// kanal ADC
#define Current_A	2
#define Volt_A		3
#define	Tempir_A	5
//----B----
#define Current_B	1
#define Volt_B		0
#define Tempir_B	4

// delay start_pwm
#define _min	0
#define _max	1

//flag_A
#define _start_pwm		BIT(0)//   0
#define _tok_on			BIT(1)
#define _tmp_flag		BIT(2)
#define _fasa1_end		BIT(3)
#define _t_r_verify		BIT(4)// 
#define _alg_on			BIT(5)
#define _01sek			BIT(7)//      -  0,1

//flag_err_A
#define _akk_error_time		BIT(0)
#define _akk_err_tempir		BIT(1)
#define _akk_error_U_hi		BIT(2)
#define _akk_error_R_hi		BIT(3)
#define _akk_err_ocr		BIT(4)
#define _akk_error_U_low	BIT(5)
#define _akk_err_stil_U		BIT(6)
#define _akk_end_charge		BIT(7)

#define uslovie_end_charge	0xFF//(_akk_end_charge|_akk_err_ocr|_akk_error_U_low|_akk_error_U_hi|_akk_error_time|_akk_err_tempir|_akk_err_stil_U)//


#define PORTLED			PORTD
#define PORTLED_2B		PORTB
#define DDRDLED			DDRD
#define PINBTN			PIND

#define sw_common	BIT(2)
#define bt_common	BIT(3)
#define led_common	BIT(4)

#define led_1_A 	BIT(5)
#define led_2_A 	BIT(6)
#define led_1_B 	BIT(7)
#define led_2_B 	BIT(0)// portb //    . sw_btn_led
#define pin_led	(led_1_A|led_2_A|led_1_B)


#define sw_on_nicd 			led_1_A
#define	sw_trickle_on		led_2_A
#define sw_alg_off			led_1_B
#define sw_enable_stop_po_ndv	led_2_B

#define btn_start_A		led_1_A
#define btn_decharge_A	led_2_A
#define btn_start_B		led_1_B
#define btn_decharge_B	led_2_B

#define ON_LED__RED_A		PORTLED|=led_2_A
#define OFF_LED__RED_A		PORTLED&=~led_2_A
#define ON_LED__GREEN_A		PORTLED|=led_1_A
#define OFF_LED__GREEN_A	PORTLED&=~led_1_A

#define ON_LED__RED_B		PORTLED_2B|=led_2_B
#define OFF_LED__RED_B		PORTLED_2B&=~led_2_B
#define ON_LED__GREEN_B		PORTLED|=led_1_B
#define OFF_LED__GREEN_B	PORTLED&=~led_1_B

#define PORTDECH	PORTB
#define	DDRDECH		DDRB
#define decharge_A	BIT(4)
#define decharge_B	BIT(3)

#define DDRPWM		DDRB
#define PORTPWM		PORTB
#define	OC1A		BIT(1)
#define	OC1B		BIT(2)

#define DDR_POWER_OFF	DDRB
#define	PORT_POWER_OFF	PORTB
#define OUT_POWER_OFF	BIT(7)

#define PIN_SEL_BOD		PINB
#define	PORT_SEL_BOD	PORTB
#define IN_SEL_BOD		BIT(5)

#define TIME_A			0//----
#define TIME_B			1//
#define TIMEOUT			2// interrupt
#define TIM_SW_BTN		3
#define CL_ISR			4//---

#define _A_		0
#define _B_		1

//#define fl_rx_buff BIT(0)


void (*funcptr)( void ) = 0x0000;

volatile int8_t time[5]={10,10,10,10,10}, flag_isr;  

volatile static uint8_t UART_TxHead, UART_TxTail;
#define UART_Tx_BUF_SIZE	64
#define UART_Tx_BUF_MASK	(UART_Tx_BUF_SIZE-1)
uint8_t	UART_Tx_buf[UART_Tx_BUF_SIZE];

static uint8_t	data_error, power_off_ON, btn, swt,
				flag_err_A, flag_err_B, flag_A, flag_B,
				clock[2],  alarm_time[2], 
				time_T, last_time_T_A, last_time_T_B, minute, trickle_minute_A, trickle_minute_B,
				state_A, state_B,
				uart_nb, UartRxBufFull, uart_buff[17],
				trickle_i, NoLargePolk; //en_I_A_B,
				
static uint16_t	Uakk_A[8],
					Uakk_B[8],
					FAST_I, tok_A, tok_B; 
static int16_t		clock_A, clock_B;

//uint32_t  ; 

// 

#define MASK_TEMPER_BUF	0b111	
int16_t temperatura[2][MASK_TEMPER_BUF+1]; 	//  MASK_TEMPER_BUF    time_T  clock_AB()
uint8_t head_T_A, head_T_B;					//    head_T  head_T+1  1  (60 / MASK_TEMPER_BUF+1 = 7,5)

#define shag_u	25//     // ADC
//'B'+'s'+int_Mh+int_Mhtr+int_Cd+int_Cdtr+min_Mh+hour_Mh+min_Cd+hour_Cd+Tofset+Tstep+'e' //int-LSB MSB
//'B' 'K' 'Mh_lsb' 'Mh_msb' 'Cd_lsb' 'Cd_msb' 'min_Mh' 'hour_Mh' 'min_Cd' 'hour_Cd' 'Tofset' 'Tstep' 'e'
#define _tofset_	12
#define _tstep_		13

struct  {
			unsigned int  tok_mh_fast;// 0,1
			unsigned char tok_mh_trickle;// 2
			unsigned char minmh; //3
			unsigned char hourmh;//4
			unsigned int  tok_cd_fast;//5 6
			unsigned char tok_cd_trickle;//7
			unsigned char mincd;//8
			unsigned char hourcd;//9
			signed char t_alarm;//10
			signed char t_increment;//11
			unsigned char tofset;//12
			unsigned char tstep;//13
			signed int  u_tempirA;//14,15
			signed int  u_tempirB;//16,17
			unsigned int  crc;//18,19
			} dprg;
#define dprg_end_wr	12
#define EEPROM_dprg	0x0A

/*
struct  {
			unsigned int  tok_mh_f;// 0,1
			unsigned int  tok_mh_tr;// 2,3
			unsigned char minmh; //4
			unsigned char hourmh;//5
			unsigned int  tok_cd_f;//6,7
			unsigned int  tok_cd_tr;//8,9
			unsigned char mincd;//10
			unsigned char hourcd;//11
			unsigned char tofset;//12
			unsigned char tstep;//13
			unsigned int  u_tempirA;//14,15
			unsigned int  u_tempirB;//16,17
			unsigned int  crc;//18,19
			} dprg;
*/


