//	20.02.10
//   .
//	startcd.narod.ru 
//	startcd@yandex.ru
//   ,     .
//	mega8  RC 8 MHz
//	v2.02     .     .
//	v2.01      UART
//	v2.00   (v1.43     )
//	v1.43  stable_adc !      ,    !
//	v1.42  swt_uart \ UART      ,  , 
//    ,   stable_adc
//	v1.41    8   
//	v1.4
//	v1.322 start_pwm   
//	v1.321    ,   7 
//	v1.32     
//	v0.31    37 .
// 	v0.3       ~32   2 
//	v0.2 
//	v0.1 ni-cd   "  "

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h> /*F_CPU = 8000000; _delay_ms max = 262.14 ms / F_CPU in MHz = 32,7675mS; _delay_us max = 768 us / F_CPU in MHz.= 96uS*/
#include "nimh8.h"

#define MIN_PRIR 0 //0- //      
#define DELTA_PRIR	2
#define NO_LARGE_POLK_NiMh	50
#define NO_LARGE_POLK_NiCd	27

ISR(TIMER0_OVF_vect){//0.00204//0,004096
//unsigned char i;
TCNT0=131;// 1/clock * 64 * 250 = 0.001
	//for(uint8_t i=0; i<5; i++){
	for(uint8_t i=4; i!=0xFF; i--){
		time[i]--;
		if ( time[i]==0 ){
			flag_isr|=_BV(i);
			if ( i == CL_ISR ) time[CL_ISR]=100;//10-0.01sek 100-0.1sek
			}
		}
}

ISR(USART_RXC_vect){
	
	time[TIMEOUT]=20;
	flag_isr &= ~_BV(TIMEOUT);
	
	uart_buff[uart_nb]=UDR;
	if ( ++uart_nb >= 17 ){
		uart_nb=0;
		if ((uart_buff[0]==0x17)&&(uart_buff[16]==0x71))
			{
				UartRxBufFull=1;
				UCSRB&=~BIT(RXCIE);
			}
		}
}

ISR(USART_UDRE_vect)
/*************************************************************************
Function: UART Data Register Empty interrupt
Purpose:  called when the UART is ready to transmit the next byte
**************************************************************************/
{
	if ( UART_TxHead != UART_TxTail) {
		uint8_t head_tx;
		head_tx = (UART_TxTail + 1) & UART_Tx_BUF_MASK;
        UDR = UART_Tx_buf[head_tx];  // start transmission 
		UART_TxTail = head_tx;
    }else{
        // tx buffer empty, disable UDRE interrupt 
        UCSRB &= ~_BV(UDRIE);
    }
}

void uart_putc(uint8_t data)
{
	uint8_t tmphead;

	tmphead  = (UART_TxHead + 1) & UART_Tx_BUF_MASK;
    
	while ( tmphead == UART_TxTail ){
		;/* wait for free space in buffer */
	}
    
	UART_Tx_buf[tmphead] = data;
	UART_TxHead = tmphead;

	/* enable UDRE interrupt */
	UCSRB   |= _BV(UDRIE);
}

static void acd_init(void)
{
	#define ADMUXSETTING	( BIT(REFS1)|BIT(REFS0) )
	ADMUX=ADMUXSETTING;
	//ADMUX=BIT(REFS1)|BIT(REFS0);//Internal 2.56V Voltage Reference with external capacitor at AREF pin
//!!!	ADCSRA=BIT(ADEN)|BIT(ADPS2)|BIT(ADPS1)|BIT(ADPS0);
	ADCSRA=BIT(ADEN)|BIT(ADPS2)|BIT(ADPS1);// clock/64 125000k time= 8uSek(*13cucles=0,000104 time conversion)
}

static void timer1_init(void)
{
	OCR1A=0x00;
	OCR1B=0x00;
	TCCR1A=BIT(WGM10);//BIT(WGM10);//Clear OC1A/OC1B on compare match//BIT(COM1A1)|BIT(COM1B1)|
	TCCR1B= BIT(WGM12)|BIT(CS10);//mode 5
	//TIMSK|=BIT(TOIE1);
}

static void timer0_init(void){
	TCCR0|=BIT(CS00)|BIT(CS01);//clock/64 0.00204
	TIMSK|=BIT(TOIE0);
}

static void port_init(void){
	DDRDECH|=decharge_A|decharge_B;
	PORTPWM&=~OC1A;//PORTB&=~BIT(PB1);
	PORTPWM&=~OC1B;//PORTB&=~BIT(PB2);
	DDRPWM|=OC1A;
	DDRPWM|=OC1B;
	//DDRD=led_common;
	
	DDR_POWER_OFF|=OUT_POWER_OFF;
	PORT_POWER_OFF|=OUT_POWER_OFF;
	PORT_SEL_BOD|=IN_SEL_BOD; //  USART_Init,  ,   9600  38400 
}

static void USART_Init( void )
{
/* Set baud rate */
	//UBRRH = (unsigned char)(baud>>8);
	if ( PIN_SEL_BOD & IN_SEL_BOD ) //  ,   9600  38400 
		UBRRL = 12; else UBRRL = 51;
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);///* Enable receiver and transmitter */
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);/* Set frame format: 8data, 2stop bit */
}

static void avr_init(void)
{
    acd_init();
	timer1_init();
	timer0_init();
	port_init();
	USART_Init();
		sei();
}
//-------------------------------------------------------------------------------------
static void power_off(void)
{	//      
	if (power_off_ON) //        
		if 
		( //         (  == 0)
		( (flag_err_A & _akk_end_charge) || (state_A==0) )
		&&
		( (flag_err_B & _akk_end_charge) || (state_B==0) )
		)
		PORT_POWER_OFF&=~OUT_POWER_OFF;
}

// ***********************************************************
//   
static inline unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));	/*     */
	EEAR = uiAddress;			/*    */
	EECR |= (1<<EERE);			/*       EERE */
	return EEDR;				/*      */
}

static void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEWE));/*     */
		cli();
		EEAR = uiAddress;/*     */
		EEDR = ucData;
		EECR |= (1<<EEMWE);/*  . 1   EEMWE */
		EECR |= (1<<EEWE);/*       EEWE */
		sei();
		}
}
//*********************************************

//--------------------------------------------
void dprg_EEPROM_write(void){
unsigned char  i, *uk;
	dprg.crc=0;
	uk=(unsigned char *)&dprg;
	for( i=0 ; i<sizeof(dprg) ; i++ ){
		EEPROM_write(i+EEPROM_dprg, *(uk+i));
		if (i<sizeof(dprg)-2)
		 dprg.crc+=*(uk+i);
		}
}
//--------------------------------------------
static void dprg_EEPROM_read(void){
unsigned char  i, *uk;
unsigned int crc_read=0;
	uk=(unsigned char *)&dprg;
	for( i=0; i<sizeof(dprg) ; i++){
		*(uk+i)=EEPROM_read(i+EEPROM_dprg);
		if (i<sizeof(dprg)-2)
			crc_read+=*(uk+i);
		}
	if (dprg.crc!=crc_read) data_error=1;
}
//--------------------------------------------
void data_init(void){
unsigned char *t;
unsigned int *a;
	if ( swt & sw_on_nicd )
		{
		a=&dprg.tok_cd_fast;
		t=&dprg.mincd;
		trickle_i=dprg.tok_cd_trickle;
		NoLargePolk=NO_LARGE_POLK_NiCd;
		}
		else
		{
		a=&dprg.tok_mh_fast;
		t=&dprg.minmh;
		trickle_i=dprg.tok_mh_trickle;
		NoLargePolk=NO_LARGE_POLK_NiMh;
		}
	FAST_I=*a;
	alarm_time[0]=*t;
	alarm_time[1]=*(t+1);
}
//-------------------------------------------------------------------------------------

/*
void USART_Transmit( unsigned char data )
{
	UCSRB|=BIT(TXEN);
// Wait for empty transmit buffer
	while ( !( UCSRA & (1<<UDRE)) )
	;
// Put data into buffer, sends the data 
	UDR = data;
}
*/
//*********************************************
static void verify_time(int16_t *time, unsigned char *flag, unsigned char state){
	if (state>20)
		if ( --(*time)<=0 ) *flag|=_akk_error_time;
}

static void clock_AB(void){
static uint8_t tim_7sek=0;
	if ( flag_isr & BIT(CL_ISR) ){
		flag_isr &=~BIT(CL_ISR);
		
		if ( ++clock[0] == 10 ){ // 1 sek
			clock[0]=0;
			if ( ++clock[1] == 60 ){ // 1 min
				clock[1]=0;
				minute++;
				verify_time(&clock_A,&flag_err_A, state_A);
				verify_time(&clock_B,&flag_err_B, state_B);
				power_off();
				}
			
			if (++tim_7sek==7) {//7 sek
				tim_7sek=0;
				time_T++;
				}
			}
		flag_A|=_t_r_verify;//0.1sek
		flag_B|=_t_r_verify;
		}
}

void set_alarm_time(int16_t *clock, unsigned char hours, unsigned char minut){
	*clock=(uint16_t)hours*60+minut;
}

//**************************************
//void delay(unsigned char i){
// while(i--);
//}
//**************************************

void delay0_01_next_state_A( unsigned char t, unsigned char next_state){
static uint8_t j, fl=0;

	if ( fl==0 ) {
		fl= 1;
		j=0;
		time[TIME_A]=10;//0.01sek
		}
	
	if (time[TIME_A]<=0){
		time[TIME_A]=10;
		if (++j>=t){
			fl = 0;
			state_A=next_state;
			}
		}
}

void delay0_01_next_state_B( unsigned char t, unsigned char next_state){
static uint8_t j, fl=0;

	if ( fl==0 ) {
		fl = 1;
		j=0;
		time[TIME_B]=10;//0.01sek
		}

	if (time[TIME_B]<=0){
		time[TIME_B]=10;
		if (++j>=t){
			fl = 0;
			state_B=next_state;
			}
		}
}


//****************************
static void pwm_A_on(void){
	TCCR1A|=BIT(COM1A1);
	OCR1A=1;//old_tok_a;					//debug
}
static void pwm_A_off(void){
	TCCR1A&=~BIT(COM1A1);
	PORTPWM&=~OC1A;
	OCR1A=0x00;
	flag_A &=~ _tok_on;
}
//----------------------------
static void pwm_B_on(void){
	TCCR1A|=BIT(COM1B1);
	OCR1B=1;//old_tok_b;					//debug
}
static void pwm_B_off(void){
	TCCR1A&=~BIT(COM1B1);
	PORTPWM&=~OC1B;
	OCR1B=0x00;
	flag_B &=~ _tok_on;
}
/******************************************************************************
static void Stable_ADC(void)                     // loop until you have a stable value
{
 
	int V[4];
	int Vmax, Vmin;
//uint8_t j, a=0;
    //Loop until the ADC value is stable. (Vmax <= (Vmin+1))
    for (Vmax=10,Vmin= 0;Vmax > (Vmin+1);)
    {
		V[3] = V[2];//  
        V[2] = V[1];
        V[1] = V[0];//   v[0]
        ADCSRA |= BIT(ADSC);                      // Start a new A/D conversion
        while ( !(ADCSRA & BIT(ADIF)) )        // wait until ADC is ready
            ;
        V[0] = ADC;
*
if (ADMUX&Volt_A) j=1; else j=2;
uart_putc( j );
uart_putc( V[0]>>8 );
uart_putc( V[0] );
uart_putc(0);//(temperatura>>8);
uart_putc(a++);//(temperatura);
*
        Vmin = V[0];                          // Vmin is the lower VOLTAGE
        Vmax = V[0];                          // Vmax is the higher VOLTAGE
        //Save the max and min voltage
        for (uint8_t i=0;i<=3;i++)
        {
            if (V[i] > Vmax)//   4   Vmax
                Vmax=V[i];
            if (V[i] < Vmin)//  Vmin  4   Vmin
				Vmin=V[i];
        }
	} //     : Vmax <= (Vmin+1)
}*/

unsigned int adc_rezult(unsigned char kanal){
	unsigned int rez=0;
	
	ADMUX=ADMUXSETTING|kanal;

	for(uint8_t i=4 ; i ; i--){
		ADCSRA|=_BV(ADSC);
		while ( !(ADCSRA & BIT(ADIF)) );
		rez+=ADC;
		}
	return rez/4;

}
//******************************************************************************

//-------------------Temperatura--------------------------------------------

//-----------------  A------------------------------------
signed int receive_t_a(void){
    static int16_t Sum = 0;
    int16_t tmp = (Sum + 2) >> 2;//    4 
    Sum += adc_rezult(Tempir_A) - tmp;
	return ( ( tmp-dprg.u_tempirA)*10/dprg.tstep )+dprg.tofset*10;
}
void verify_t_A(void){

	int16_t t=receive_t_a();

	if (last_time_T_A	!=	time_T){//7sek
		last_time_T_A	=	time_T;

		temperatura[_A_][head_T_A]=t;// ,      
		head_T_A=(head_T_A+1) & MASK_TEMPER_BUF;//  ,    
		
		if ( t-temperatura[_A_][head_T_A] >= dprg.t_increment ) 
				flag_err_A|=_akk_err_tempir;
		}
	
	if (  t >= dprg.t_alarm*10 )  
			flag_err_A|=_akk_err_tempir;
}

//-----------------  B------------------------------------
signed int receive_t_b(void){
    static int16_t Sum = 0;
    int16_t tmp = (Sum + 2) >> 2;
    Sum += adc_rezult(Tempir_B) - tmp;
	return ( ( tmp-dprg.u_tempirB)*10/dprg.tstep )+dprg.tofset*10;
}
void verify_t_B(void){

	int16_t t=receive_t_b();

	if (last_time_T_B	!=	time_T){
		last_time_T_B	=	time_T;
		
		temperatura[_B_][head_T_B]=t;// ,      
		head_T_B=(head_T_B+1) & MASK_TEMPER_BUF;//  ,    
		
		if ( t-temperatura[_B_][head_T_B] >= dprg.t_increment ) 
				flag_err_B|=_akk_err_tempir;
		}
	
	if (  t >= dprg.t_alarm*10 )  
			flag_err_B|=_akk_err_tempir;
}

//-----------------Init_masiw for usrednenie------------------------------
static void tempir_init_massif_a( void ){
	for(uint8_t i=50; i; i--) receive_t_a();
	for(uint8_t i=0; i<MASK_TEMPER_BUF+1; i++) temperatura[_A_][i]=receive_t_a();
}
static void tempir_init_massif_b( void ){
	for(uint8_t i=50; i; i--) receive_t_b();
	for(uint8_t i=0; i<MASK_TEMPER_BUF+1; i++) temperatura[_B_][i]=receive_t_b();
}
//-----------------End-Temperatura----------------------------------------

//------------------Send_UART_STR-----------------------------------------
void send_str(unsigned char kanal){
uint16_t *U;
uint8_t j;	
	if ( kanal==_A_ ) {
			U=Uakk_A;
			j=(head_T_A-1) & MASK_TEMPER_BUF;
			}
			else {
			U=Uakk_B;
			j=(head_T_B-1) & MASK_TEMPER_BUF;
			}
		
	uart_putc(kanal+1);
	uart_putc( U[0]>>8 );
	uart_putc( U[0] );
	uart_putc(temperatura[kanal][j]>>8);//(temperatura>>8);
	uart_putc(temperatura[kanal][j]);//(temperatura);
}
void send_internal_r(uint8_t kanal){
uint16_t *u;

	if ( kanal==_A_ ) {
			u=Uakk_A;
			}
			else {
			u=Uakk_B; 
			}
	uart_putc(kanal+5);
	uart_putc( u[0]>>8 );
	uart_putc( u[0] );
	uart_putc( u[1]>>8 );
	uart_putc( u[1] );
	
}

void send_state(uint8_t kanal){
	uart_putc( kanal+7 );
	uart_putc( FAST_I>>8 );
	uart_putc( FAST_I );
	uart_putc( swt );
	uart_putc( 0 );
}

void send_end_err_str(unsigned char kanal){
unsigned char *u;	
	if ( kanal==_A_ ) u=&flag_err_A; else u=&flag_err_B; 
	uart_putc(kanal+3);	//  
	uart_putc(*u);
	uart_putc(0);
	uart_putc(0);
	uart_putc(0);
}
//----------------END--Send_UART_STR--------------------------------------

//---------------------Kanal_A--------------------------------------------------
static void verify_error_A(void){
	if ( flag_err_A & uslovie_end_charge ){
		pwm_A_off();
		PORTDECH&=~decharge_A;
		OFF_LED__GREEN_A;
		ON_LED__RED_A;
		state_A=1;
		if ( flag_err_A & _akk_end_charge )	power_off_ON=1; else send_str(_A_);
		}
}
//************************************
static void verify_tok_A(void)
{
unsigned int Iakk_A, ocr;

	if ( flag_A & _tok_on ){
		Iakk_A=adc_rezult(Current_A);
		ocr=OCR1A;
		if (Iakk_A<tok_A){
			if ( ++ocr > 200 ) flag_err_A |= _akk_err_ocr;
			}
		else
		if (Iakk_A>tok_A){
			if (ocr>1)
				ocr--;
			}
		OCR1A=ocr;
		/*	
			if ( ++data_error==100) data_error=0;
			ocr[data_error]=OCR1A;
			adc[data_error]=(unsigned char)Iakk_A;
			Iakk_A=0;
		*/	
		}
}
//************************************
void verify_r_A(void){
unsigned int Uakk, Ur;
	Ur=adc_rezult(Current_A);
	Uakk=adc_rezult(Volt_A);
	if ( Uakk-Ur>740 ) flag_err_A|=_akk_error_R_hi;// U>1.85V
}
//************************************
void verify_r_t_A(void){//  R  t,   0,2 .
static uint8_t sequence;
	if (flag_A & _t_r_verify){
		flag_A &= ~_t_r_verify;
		if ( (++sequence) & _BV(0) )
			verify_r_A();//
			else
			verify_t_A();//  
		}
}
//************************************
unsigned int stop_pwm_U_rec_A(void){
unsigned int U;
	pwm_A_off();
	ADMUX=ADMUXSETTING|Volt_A;
	//Stable_ADC();//
	U=adc_rezult(Volt_A);
	if ( U<160 )
		flag_err_A|=_akk_error_U_low;//  0,4v
	else	
	if (U>640)
		flag_err_A|=_akk_error_U_hi;//>1.81V
	return U;
}
//************************************
void start_pwm_A( unsigned int tok_, unsigned char state_ )
{
//    ,
	if ( !(flag_A & _start_pwm) ){
		flag_A |= _start_pwm;
		flag_A&=~_tok_on;
		tok_A=tok_;
		time[TIME_A]=1;
		pwm_A_on();
		}
	
	if ( flag_isr & BIT(TIME_A) ){
		flag_isr &=~BIT(TIME_A);
		time[TIME_A]=2;

		if (  adc_rezult(Current_A) >= tok_A){
			flag_A|= _tok_on;
			flag_A&=~_start_pwm;
			state_A=state_;
			return;
			}
		
		uint16_t
		ocr=OCR1A;
		if ( ++ocr > 200 ) {flag_err_A |= _akk_err_ocr;}
		OCR1A=ocr;
		}
}
//---------------------End--Kanal_A---------------------------------------------

//---------------------Kanal_B--------------------------------------------------
static void verify_error_B(void){
	if ( flag_err_B & uslovie_end_charge ){//
		pwm_B_off();
		PORTDECH&=~decharge_B;
		OFF_LED__GREEN_B;
		ON_LED__RED_B;
		state_B=1;
		if ( flag_err_B & _akk_end_charge ) power_off_ON=1; else send_str(_B_);
		}
}
//************************************
static void verify_tok_B(void)
{
unsigned int Iakk_B, ocr;

	if ( flag_B & _tok_on ){
		Iakk_B=adc_rezult(Current_B);
		ocr=OCR1B;
		if (Iakk_B<tok_B){
			if ( ++ocr > 200 ) flag_err_B |= _akk_err_ocr;
			}
		else
		if (Iakk_B>tok_B){
			if (ocr>1)
				ocr--;
			}
		OCR1B=ocr;
		}
}
//************************************
void verify_r_B(void){
unsigned int Uakk, Ur;
	Ur=adc_rezult(Current_B);
	Uakk=adc_rezult(Volt_B);
	if ( Uakk-Ur>740 ) flag_err_B|=_akk_error_R_hi;// U>1.85V
}
//************************************
void verify_r_t_B(void){//  R  t,   0,2 .
static uint8_t sequence;
	if (flag_B & _t_r_verify){
		flag_B &= ~_t_r_verify;
		if ( (++sequence) & _BV(0) )
			verify_r_B();//
			else
			verify_t_B();//  
		}
}
//************************************
unsigned int stop_pwm_U_rec_B(void){
unsigned int U;
	pwm_B_off();
	ADMUX=ADMUXSETTING|Volt_B;
	//Stable_ADC();//
	U=adc_rezult(Volt_B);
	if ( U<160 )
		flag_err_B|=_akk_error_U_low;//  0,4v
	else	
	if (U>640)
		flag_err_B|=_akk_error_U_hi;//>1.81V(680)debug
	return U;
}
//************************************
void start_pwm_B( unsigned int tok_, unsigned char state_ )
{
//    ,
	if ( !(flag_B & _start_pwm) ){
		flag_B |= _start_pwm;
		flag_B&=~_tok_on;
		tok_B=tok_;
		time[TIME_B]=1;
		pwm_B_on();
		}
	
	if ( flag_isr & BIT(TIME_B) ){
		flag_isr &=~BIT(TIME_B);
		time[TIME_B]=2;

		if (  adc_rezult(Current_B) >= tok_B){
			flag_B|= _tok_on;
			flag_B&=~_start_pwm;
			state_B=state_;
			return;
			}
		
		uint16_t	
		ocr=OCR1B;
		if ( ++ocr > 200 ) {flag_err_B |= _akk_err_ocr;}// old_tok_b=1;}
		OCR1B=ocr;
		}
}
//---------------------End--Kanal_B---------------------------------------------

//------------------Scan--Button--------------------
unsigned char sw_btn_led(unsigned char com){
unsigned char tmp,tmp2,rezult;

	DDRDLED=0;//DDRDLED&=~(sw_common|bt_common|led_common); //   Z 
	DDRB&=~BIT(0);//~led_2_B
	tmp=PORTLED&pin_led;//  led
	tmp2=PORTB;//&BIT(0);//  led
	PORTLED|=pin_led;//pullup
	PORTB|=BIT(0);//pullup
	DDRDLED=com;//  PORT=0 DDR=1   0
	_delay_us(5);
	rezult=PINBTN&pin_led; //0b1110_0000
	if ( PINB & BIT(0) ) rezult|=BIT(0);
	PORTLED&=tmp|(~pin_led);//  led
	if ( ( tmp2&BIT(0) )==0 ) PORTB&=~BIT(0);//PORTB&=tmp2|0xFE;	//  led
	DDRDLED=0;// 
	DDRDLED=led_common|pin_led;
	DDRB|=BIT(0);//led_2_B
	return ~rezult;
}
//------------------Begin--Button--------------------
static void state_A_0(void){
	if ( btn & btn_decharge_A )
		{
		state_A=0;//     
		if (state_B==0) 	{UCSRB|=_BV(RXEN); UCSRB|=_BV(RXCIE);}//   
		OFF_LED__GREEN_A;
		OFF_LED__RED_A;
		}
}


static void start_charge_A(void){
	if ( btn & btn_start_A ){
		if ( btn & btn_decharge_A ) 
			state_A=120;
			else
			state_A=20;
		UCSRB&=~_BV(RXCIE);
		UCSRB&=~_BV(RXEN);
		data_init();
		}
}
//----------------------------------------------
static void state_B_0(void){
	if ( btn & btn_decharge_B ){
		state_B=0;
		if (state_A==0) 	{UCSRB|=_BV(RXEN); UCSRB|=_BV(RXCIE);}//   
		OFF_LED__GREEN_B;
		OFF_LED__RED_B;
		}
}

static void start_charge_B(void){

	if ( btn & btn_start_B ){
		if ( btn & btn_decharge_B ) 
			state_B=120;
			else
			state_B=20;
		UCSRB&=~_BV(RXCIE);
		UCSRB&=~_BV(RXEN);
		data_init();
		}
}
//-----------------End-----Button--------------------

//-----------------Begin---seting--------------------
/*static void cls_uart_buff(void){
unsigned char i;
	for(i=0; i< sizeof(uart_buff) ; i++)
	uart_buff[i]=0;
}*/

void seting(void){
unsigned char  *uk, i;

	cli();
	if ( flag_isr & _BV(TIMEOUT) ) uart_nb=0;
	sei();	
	
	if ( UartRxBufFull ) 
		{
		switch (uart_buff[1])
			{
			case (0x01):// reset
				(*funcptr)();
				break;
			case (0x10)://   EEPROM
				uk=(unsigned char*)&dprg;
				for( i=0; i < dprg_end_wr ; i++)
					*(uk+i)=uart_buff[i+2];
				dprg_EEPROM_write();
				data_error=0;
				PORTLED&=~pin_led;//led on
				OFF_LED__RED_B;
				//break;
			case (0x20)://  
				uk=(unsigned char *)&dprg;
				for (i=0; i<sizeof(dprg) ; i++)//
					uart_putc( *(uk+i) );//
				break;
			case (0x30)://    
				if (uart_buff[2]==0x30){
					dprg.tofset=uart_buff[_tofset_];
					dprg.tstep=uart_buff[_tstep_];
					uint16_t adc=0;
					for( i=8; i  ; i-- ) adc+=adc_rezult(Tempir_A);
					dprg.u_tempirA=adc/8;    //adc_rezult(Tempir_A);
					adc=0;
					for( i=8; i  ; i-- ) adc+=adc_rezult(Tempir_B);
					dprg.u_tempirB=adc/8;    //adc_rezult(Tempir_B);
					dprg_EEPROM_write();
					//uart_flag&=~fl_rx_buff;
					}
			case (0x31)://  	
				uart_putc(0x30);
				int16_t t;
				t=receive_t_a();
				uart_putc( t>>8 );
				uart_putc( t );
				t=receive_t_b();
				uart_putc( t>>8 );
				uart_putc( t );
				break;
	
			}
			//cls_uart_buff();
			UartRxBufFull=0;
			UCSRB|=BIT(RXCIE);
		}
}
//--------------end---seting------------------------


int main(void)
{
uint8_t usr_a=0, usr_b=0;
int8_t current_a=0, max_a=0, count_a=0, tmp_a=0, no_polk_a=0;
int8_t current_b=0, max_b=0, count_b=0, tmp_b=0, no_polk_b=0;
uint16_t Uakk_usr_B=0, Uakk_usr_A=0;


{
uint8_t p;
p=pgm_read_byte_near(&osccal);// adress = 0x26
if ( p != 0xFF )
	OSCCAL=p;
}

    avr_init();
	dprg_EEPROM_read();

	sw_btn_led(bt_common);//-----------------
	PORTLED|=pin_led;//led on
	ON_LED__RED_B;//-------------------

	//-------delay 1sek-----------
	state_A=1;
	do
	{
	delay0_01_next_state_A(100,0);
	clock_AB();
	//seting();
	}
	while(state_A);
	//---------delay 1sek-----------

	if (!data_error){
		PORTLED&=~pin_led;//led on
		OFF_LED__RED_B;
		}
	
	set_alarm_time(&clock_A,10,00);
	set_alarm_time(&clock_B,10,00);

while(1)
{

//***************************************************************************
	clock_AB();
	
	
	if ( flag_isr & BIT(TIM_SW_BTN) )
		{
		flag_isr &= ~BIT(TIM_SW_BTN);
		swt=sw_btn_led(sw_common);
		btn=sw_btn_led(bt_common);
		}
//***************************************************************************

	switch (state_A)
	{
		case (0):
			//  
			seting();
			
			if (!data_error)
				{
				state_A_0();
				start_charge_A();
				}
			break;
		//---------------------error------------------------
		case (1):
			send_end_err_str(_A_);
			if ( flag_err_A & _akk_end_charge )
						state_A=0;
				else  	state_A=2;	
			tmp_a=1;
			count_a=flag_err_A;
			flag_err_A=0;
			break;
		case (2):
			ON_LED__RED_A;
			delay0_01_next_state_A(40,3);
			break;
		case (3):
			OFF_LED__RED_A;
			//start_charge_A();
			state_A_0();
			delay0_01_next_state_A(30,4);
			break;
		case (4):
			if	( tmp_a&count_a )
				state_A=5;
				else
				state_A=2;
			tmp_a<<=1;
			break;
		case (5):
			tmp_a=1;
			//start_charge_A();
			state_A_0();
			delay0_01_next_state_A(120,2);
			break;
		//------------------end--error---------------------
		case (20):
			
			PORTDECH&=~decharge_A;
			ON_LED__GREEN_A;
			OFF_LED__RED_A;

			usr_a=0, current_a=0, max_a=0, count_a=0, tmp_a=0, no_polk_a=0;
			flag_err_A=0;
			flag_A=0;
			power_off_ON=0;
			Uakk_usr_A=0;
			
			tempir_init_massif_a();//     	
			
			set_alarm_time(&clock_A,00,30);
			verify_t_A();//  
			
			send_state(_A_);
			Uakk_A[0]=stop_pwm_U_rec_A();//   .  U>0.8?
			//send_str(_A_);
			
			tmp_a=25;
			if (Uakk_A[0]>360)
				state_A=21;
				else
				state_A=25;
			break;
		
		case (21)://----------------[  R  ]---------------------
			//  tmp    
			//  ,  Uakk_A[0]    . .  , . .  .
			PORTDECH|=decharge_A;//  
			delay0_01_next_state_A(100,22);// /10 8
			break;
		case (22):
			Uakk_A[1]=stop_pwm_U_rec_A();
			PORTDECH&=~decharge_A;//  
			send_internal_r(_A_);
			//send_str(_A_);
			state_A=tmp_a;
			break;//----------------[  R  ]---------------------
		
		case (25)://************************[    ]*************************
			start_pwm_A( 40, 27 );//  ~ 200ma
			break;
		case (27):
			delay0_01_next_state_A(150,28);
			verify_r_t_A();
			break;
		case (28)://#########decharge_imp##########
			pwm_A_off();
			PORTDECH|=decharge_A;//  
			ON_LED__RED_A;	//   ,   1   
			state_A=29;
			break;
		case (29):
			delay0_01_next_state_A(2,30);//  0,02
			break;
		case (30):
			if ( stop_pwm_U_rec_A()>400 ) state_A=50; //   1.0v  
			else	state_A=25;//     U>1
			OFF_LED__RED_A;
			PORTDECH&=~decharge_A;//  
			break;//**********************[ end    ]**********************	
		
		//----------------------------------[    ]-------------------------------	
		case (50)://***********[    ]**************
			set_alarm_time(&clock_A,alarm_time[1],alarm_time[0]);// 
			state_A=51;
			break;
		case (51):
			state_A=52;
			start_pwm_A( FAST_I, 82 );
			break;
		case (52):
			delay0_01_next_state_A(100,51);
			verify_r_t_A();
			break;//***********[    ]**************	
		
		case (70)://**************[ FAST CHARGE ]*********************
		//  ,  U   dV0,  ,
			Uakk_usr_A+=stop_pwm_U_rec_A();
			PORTDECH&=~decharge_A;// .  
			OFF_LED__RED_A;
	
			int8_t prir=0;
			
			if ( ++usr_a >= USR_N )
			{
			for ( tmp_a=7 ; tmp_a>0 ; tmp_a-- ){//    
				Uakk_A[tmp_a]=Uakk_A[tmp_a-1];
				}
			Uakk_A[0]=Uakk_usr_A/USR_N;
			Uakk_usr_A=usr_a=0;	
			
			send_str(_A_);
//state_A=80;
//break;
			
			for ( tmp_a=0; tmp_a<7 ; tmp_a++ )//  
				prir+= (signed char)(Uakk_A[tmp_a]-Uakk_A[tmp_a+1]);
				
			//    
			if (  flag_A & _alg_on  )
				{//-------------ALGORITM-------------------------------------------
				
				if (swt & sw_on_nicd) 
					if (swt & sw_alg_off) {
						state_A=80;// NiCd   sw_alg_off,    ,   
						break;
						}

				if (prir<0){// 
					// 
					state_A=130;// 
					break;
					}
				
				if (  (flag_A & _fasa1_end)==0 )
					{
					if ( Uakk_A[0]<=Uakk_A[1] )
						{ 
						current_a++;
						if ( current_a==15 ) //   15    ,    ,   NiMh
							{flag_err_A|=_akk_err_stil_U; break;}
						}
						else
						{
						tmp_a=0;
						if (current_a>=max_a) //>=
							{
							max_a=current_a;
							count_a=0;
							}
						if (current_a<max_a)	
							{
							count_a++;
							if (count_a>7) tmp_a=1;
							}
						if ( max_a <= 4 ){
							if ( ++no_polk_a==NoLargePolk ) tmp_a=1; //      2 
							} else no_polk_a=0;
						current_a=0;
						
						if (tmp_a) {
							flag_A|=_fasa1_end;
							current_a=max_a=count_a=tmp_a=0;
							}
						}
					}
					else//fasa2
					{
					current_a=prir;
					if ( current_a > max_a ) max_a=current_a;
					if ( max_a >= current_a+2 ) count_a++; else count_a=0;		
					#if ( MIN_PRIR ) 
					if ( prir <= MIN_PRIR )
					#endif
					if ( count_a>=DELTA_PRIR )	//end charge
						{	
						if ( swt & sw_trickle_on ) 
							state_A=100;//
							else
							state_A=130;// 
						break;
						}
					}
				}//-----------END---------ALGORITM---------------------------------------
				else{// 
				if (++count_a==8){count_a=0;flag_A|=_alg_on;} // 8  
				}
			}
			state_A=80;
			break;
		//---------------------[ decharge_imp ]---------------------------------
		case (80)://----------------------------------------------------------------
			start_pwm_A( FAST_I,81);// 
			break;
		case (81):
			delay0_01_next_state_A(TIME_CH,82);// /10 //40 old=9
			verify_r_t_A();
			break;
		case (82)://#########decharge_imp##########
			pwm_A_off();
			PORTDECH|=decharge_A;//  
			ON_LED__RED_A;
			state_A=83;
			break;
		case (83):
			delay0_01_next_state_A(TIME_DECH,70);// /10 8
			break;
		//**************[ END FAST CHARGE ]*********************

		//--------------   30  ----------------------
		case (100):
			tmp_a=31;
			ON_LED__RED_A;
			set_alarm_time(&clock_A,00,35);
			send_end_err_str(_A_);
			state_A=101;
			break;
		case (101):
			start_pwm_A( trickle_i,102);
			break;
		case (102):
			delay0_01_next_state_A(20,103);// 10
			OFF_LED__GREEN_A;
			break;
		case(103):
			delay0_01_next_state_A(20,104);// 10
			ON_LED__GREEN_A;
			break;
		case(104):
			state_A=102;
			verify_r_A();
			verify_t_A();
			if ( trickle_minute_A != minute ){// 1 
				trickle_minute_A=minute;
				pwm_A_off();
				PORTDECH|=decharge_A;//  
				state_A=105;
				}
			break;
		case(105):
			delay0_01_next_state_A(1,106);// 10
			break;
		case(106):
			Uakk_A[0]=stop_pwm_U_rec_A();
			PORTDECH&=~decharge_A;// .  
			state_A=101;
			if ( --tmp_a==0 ) state_A=130;
				else send_str(_A_);
			break;
		//----------END-   30  ----------------------
	
		//--------------  1 --------------------
		case (120):
			pwm_A_off();
			flag_A=0;
			power_off_ON=0;
			count_a=29;
			OFF_LED__GREEN_A;
			ON_LED__RED_A;
			if ( !(btn & btn_decharge_A) ) {
				state_A=124;
				}
			break;
			
		case (121):
			PORTDECH|=decharge_A;// 
			ON_LED__GREEN_A;
			ON_LED__RED_A;
			delay0_01_next_state_A(100,122);// 10
			if ( btn & btn_decharge_A ) state_A=122;
			break;
		case (122):
			OFF_LED__RED_A;
			OFF_LED__GREEN_A;
			delay0_01_next_state_A(100,123);// 10
			if ( btn & btn_decharge_A ){
				state_A=0;
				PORTDECH&=~decharge_A;
				}
			break;	
		case (123):
			state_A=121;
			verify_t_A();
			Uakk_A[0]=stop_pwm_U_rec_A();
			flag_err_A=0; 
			if ( Uakk_A[0]<400 ){// <1v
				state_A=20;
				PORTDECH&=~decharge_A;
				send_str(_A_);
				break;
				}
			
			if ( ++count_a==30 ) {
			//if ( ++tmp_a==30 ) {
				//tmp_a=0;
				count_a=0;
				send_str(_A_);
				}
			
			break;
		case (124):
			ON_LED__GREEN_A;
			set_alarm_time(&clock_A,10,00);
			tempir_init_massif_a();
			
			send_state(_A_+2);//  ""
			
			Uakk_A[0]=stop_pwm_U_rec_A();
			tmp_a=121;
			state_A=21;//  .
			break;
			
		//--------------  1 --------------------
			
		case(130):
			Uakk_A[0]=stop_pwm_U_rec_A();
			//send_str(_A_);
			tmp_a=131;
			state_A=21;
			break;
		case(131):
			flag_err_A|=_akk_end_charge;
			break;
	}
	//***********************************************************************
		verify_error_A();
		verify_tok_A();
	//***********************************************************************
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	switch (state_B)
	{
		case (0):
			if (!data_error)
				{
				state_B_0();
				start_charge_B();
				}
			break;
		//---------------------error------------------------
		case (1):
			/*if ( swt & sw_uart ) {
				uart_putc(0x04);	// 2 
				uart_putc(flag_err_B);
				uart_putc(0);
				uart_putc(0);
				uart_putc(0);
				}*/
			send_end_err_str(_B_);
			if ( flag_err_B & _akk_end_charge )
						state_B=0;
				else  	state_B=2;	
			tmp_b=1;
			count_b=flag_err_B;
			flag_err_B=0;
			break;
		case (2):
			ON_LED__RED_B;
			delay0_01_next_state_B(40,3);
			break;
		case (3):
			OFF_LED__RED_B;
			//start_charge_B();
			state_B_0();
			delay0_01_next_state_B(30,4);
			break;
		case (4):
			if	( tmp_b&count_b )
				state_B=5;
				else
				state_B=2;
			tmp_b<<=1;
			break;
		case (5):
			tmp_b=1;
			//start_charge_B();
			state_B_0();
			delay0_01_next_state_B(120,2);
			break;
		//------------------end--error---------------------
		case (20):
			
			PORTDECH&=~decharge_B;
			ON_LED__GREEN_B;
			OFF_LED__RED_B;
			
			usr_b=0; current_b=0, max_b=0, count_b=0, tmp_b=0, no_polk_b=0;
			flag_err_B=0;
			flag_B=0;
			power_off_ON=0;
			Uakk_usr_B=0;

			//for(int8_t j=sizeof(Uakk_B)/2-1; j!=-1; j--) Uakk_B[j]=0;
			
			tempir_init_massif_b();//    

			set_alarm_time(&clock_B,00,30);
			verify_t_B();//  
			
			send_state(_B_);
			Uakk_B[0]=stop_pwm_U_rec_B();//   .  U>0.8?
			//send_str(_B_);
			
			tmp_b=25;
			if (Uakk_B[0]>360)
				state_B=21;
				else
				state_B=25;
			break;
				
		case (21)://----------------[  R  ]---------------------
			//  tmp    
			//  ,  Uakk_A[0]    . .  , . .  .
			PORTDECH|=decharge_B;//  
			delay0_01_next_state_B(100,22);// /10 8
			break;
		case (22):
			Uakk_B[1]=stop_pwm_U_rec_B();
			PORTDECH&=~decharge_B;// .  
			send_internal_r(_B_);
			//send_str(_B_);
			state_B=tmp_b;
			break;//----------------[  R  ]---------------------
			
		case (25)://************************[    ]*************************
			start_pwm_B( 40, 27 );//  ~ 100ma
			break;
		case (27):
			delay0_01_next_state_B(150,28);
			verify_r_t_B();
			break;
		case (28)://#########decharge_imp##########
			pwm_B_off();
			PORTDECH|=decharge_B;//  
			ON_LED__RED_B;
			state_B=29;
			break;
		case (29):
			delay0_01_next_state_B(2,30);// /10 8
			break;
		case (30):
			if ( stop_pwm_U_rec_B()>400 ) state_B=50; //     
			else	state_B=25;//     U>1
			OFF_LED__RED_B;			
			PORTDECH&=~decharge_B;// .  
			break;//**********************[ end    ]**********************	
		
		//----------------------------------[    ]-------------------------------	
		case (50)://***********[    ]**************
			set_alarm_time(&clock_B,alarm_time[1],alarm_time[0]);// 
			state_B=51;
			break;
		case (51):
			state_B=52;
			start_pwm_B( FAST_I, 82 );
			break;
		case (52):
			delay0_01_next_state_B(100,51);//  1sek
			verify_r_t_B();
			break;//***********[    ]**************
		
		case (70)://**************[ FAST CHARGE ]*********************
		//  ,  U   dV0,  ,
			Uakk_usr_B+=stop_pwm_U_rec_B();
			PORTDECH&=~decharge_B;// .  
			OFF_LED__RED_B;
			
			int8_t prir=0;
			
			if ( ++usr_b >= USR_N )
			{
			for ( tmp_b=7 ; tmp_b>0 ; tmp_b-- ){//    
				Uakk_B[tmp_b]=Uakk_B[tmp_b-1];
				}
			Uakk_B[0]=Uakk_usr_B/USR_N;
			Uakk_usr_B=usr_b=0;	
			
			send_str(_B_);
//state_B=80;
//break;
			
			for ( tmp_b=0; tmp_b<7 ; tmp_b++ )//  
				prir+= (signed char)(Uakk_B[tmp_b]-Uakk_B[tmp_b+1]);
			
			//    
			if (  flag_B & _alg_on  )
				{//-------------ALGORITM-------------------------------------------
				
				if (swt & sw_on_nicd) 
					if (swt & sw_alg_off) {
						state_B=80;// NiCd   sw_alg_off,    ,   
						break;
						}
				
				if (prir<0){// 
					// 
					state_B=130;// 
					break;
					}
				
						
				if (  (flag_B & _fasa1_end)==0 )
					{
					if ( Uakk_B[0]<=Uakk_B[1] )
						{ 
						current_b++;
						if ( current_b==15 ) //   15    ,    ,   NiMh
							if ( !(swt & sw_on_nicd) ) {flag_err_B|=_akk_err_stil_U; break;}
						}
						else
						{
						tmp_b=0;
						if (current_b>=max_b) //>=
							{
							max_b=current_b;
							count_b=0;
							}
						if (current_b<max_b)	
							{
							count_b++;
							if (count_b>7) tmp_b=1;
							}
						if ( max_b <= 4 ){
							if ( ++no_polk_b==NoLargePolk ) tmp_b=1; //      2 
							} else no_polk_b=0;
						current_b=0;
						
						if (tmp_b) {
							flag_B|=_fasa1_end;
							current_b=max_b=count_b=tmp_b=0;
							}
						}
					}
					else//fasa2
					{
					current_b=prir;
					if ( current_b > max_b ) max_b=current_b;
					if ( max_b >= current_b+2 ) count_b++; else count_b=0;		
					#if ( MIN_PRIR ) 
					if ( prir <= MIN_PRIR )
					#endif
					if (count_b>=DELTA_PRIR)	//end charge
						{	
						if ( swt & sw_trickle_on ) 
							state_B=100;//
							else
							state_B=130;// 
						//if (swt & sw_on_nicd) if (swt & sw_alg_off)  state_B=80;// NiCd   sw_alg_off,    ,   
						break;
						}
					}
				}//-----------END---------ALGORITM---------------------------------------
				else{// 
				if (++count_b==8){count_b=0;flag_B|=_alg_on;} // 8  
				}
			}
			state_B=80;
			break;
		//---------------------[ decharge_imp ]---------------------------------
		case (80)://-----------------------------------------------------------
			start_pwm_B( FAST_I,81);//        .
			break;	
		case (81):
			delay0_01_next_state_B(TIME_CH,82);// /10 //40 old=9
			verify_r_t_B();
			break;	
		case (82)://#########decharge_imp##########
			pwm_B_off();
			PORTDECH|=decharge_B;//  
			ON_LED__RED_B;
			state_B=83;
			break;
		case (83):
			delay0_01_next_state_B(TIME_DECH,70);// /10 8
			break;
		//**************[ END FAST CHARGE ]*********************
		
		//--------------   30  ----------------------
		case (100):
			tmp_b=31;
			ON_LED__RED_B;
			set_alarm_time(&clock_B,00,35);
			send_end_err_str(_B_);
			state_B=101;
			break;
		case (101):
			start_pwm_B( trickle_i,102);
			break;
		case (102):
			delay0_01_next_state_B(20,103);// 10
			OFF_LED__GREEN_B;
			break;
		case(103):
			delay0_01_next_state_B(20,104);// 10
			ON_LED__GREEN_B;
			break;
		case(104):
			state_B=102;
			verify_r_B();
			verify_t_B();
			if ( trickle_minute_B != minute ){// 1 
				trickle_minute_B=minute;
				pwm_B_off();
				PORTDECH|=decharge_B;//  
				state_B=105;
				}
			break;
		case(105):
			delay0_01_next_state_B(1,106);// 10
			break;
		case(106):
			Uakk_B[0]=stop_pwm_U_rec_B();
			PORTDECH&=~decharge_B;// .  
			state_B=101;
			if ( --tmp_b==0 ) state_B=130;
				else send_str(_B_);
			break;
		//----------END-   30  ----------------------		
		
		//--------------  1 -----------------
		case (120):
			pwm_B_off();
			flag_B=0;
			power_off_ON=0;
			count_b=29;
			OFF_LED__GREEN_B;
			ON_LED__RED_B;
			if ( !(btn & btn_decharge_B) ) {
				state_B=124;
				}
			break;
		
		case (121):
			PORTDECH|=decharge_B;
			ON_LED__GREEN_B;
			ON_LED__RED_B;
			delay0_01_next_state_B(100,122);// 10
			if ( btn & btn_decharge_B ) state_B=122;
			break;
		case (122):
			OFF_LED__RED_B;
			OFF_LED__GREEN_B;
			delay0_01_next_state_B(100,123);// 10
			if ( btn & btn_decharge_B ){
				state_B=0;
				PORTDECH&=~decharge_B;
				}
			break;	
		case (123):
			state_B=121;
			verify_t_B();
			Uakk_B[0]=stop_pwm_U_rec_B();
			flag_err_B=0;
			if ( Uakk_B[0]<400 ){
				state_B=20;
				PORTDECH&=~decharge_B;
				send_str(_B_);
				break;
				}
			
			if ( ++count_b==30 ) {
				count_b=0;
				send_str(_B_);
				}
			
			break;
			
		case (124):
			ON_LED__GREEN_B;
			set_alarm_time(&clock_B,10,00);
			tempir_init_massif_b();//           
			
			send_state(_B_+2);//  ""
			Uakk_B[0]=stop_pwm_U_rec_B();
			
			tmp_b=121;
			state_B=21;
			break;	
			//--------------  1 --------------------
		
		case(130):
			Uakk_B[0]=stop_pwm_U_rec_B();
			//send_str(_B_);
			tmp_b=131;
			state_B=21;
			break;
		case(131):
			flag_err_B|=_akk_end_charge;
			break;

	}
	//***********************************************************************
		verify_error_B();
		verify_tok_B();
	//***********************************************************************

}

}










